package ru.dbotthepony.mc.otm.block;

import net.minecraft.core.Direction;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.EnumProperty;
import org.apache.commons.lang3.ArrayUtils;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;

import javax.annotation.Nullable;
import java.util.Arrays;

public abstract class BlockMatteryRotatable extends BlockMattery {
	public static final EnumProperty<Direction> FACING = EnumProperty.create(
		"facing",
		Direction.class,
		Direction.SOUTH,
		Direction.WEST,
		Direction.NORTH,
		Direction.EAST);

	public BlockMatteryRotatable() {
		super();

		registerDefaultState(this.getStateDefinition().any().setValue(FACING, Direction.SOUTH));
	}

	@Override
	protected void createBlockStateDefinition(StateDefinition.Builder<Block, BlockState> builder) {
		builder.add(FACING);
	}

	@Nullable
	@Override
	public BlockState getStateForPlacement(BlockPlaceContext context) {
		return this.defaultBlockState().setValue(FACING, faceToPlayer(context) ? context.getHorizontalDirection().getOpposite() : context.getHorizontalDirection());
	}

	public boolean faceToPlayer(BlockPlaceContext context) {
		return true;
	}
}
